︠96ca0450-d6b1-4590-9ee2-610d1b1075fb︠
# Problem set 2
︡75057974-ac35-4dee-8d35-76d3995eb3cb︡
︠96d4895f-7e29-40de-afc4-06c78de11b9fs︠
reset
︡8e30e303-28dd-4b44-80b0-0dde843be5ac︡{"stdout":"<function reset at 0x7f5816de7050>\n"}︡{"done":true}
︠9213985d-44ff-4567-b5f1-122daa789a4a︠
#Some useful SageMath commands
#prime_range:
prime_range(20)
︡37ad6da1-187d-48e7-9013-1b6daf204a3b︡{"stdout":"[2, 3, 5, 7, 11, 13, 17, 19]\n"}︡{"done":true}
︠1d0d403e-5bdb-4ae6-b944-1dbbf7546e15︠
#next_prime, previous_prime
next_prime(15)
︡f066cc4b-fcb6-46b6-a407-fa22658f217d︡{"stdout":"17\n"}︡{"done":true}
︠f828451a-9eaf-4525-a908-b38827916484︠
#ceiling function:
ceil(13^0.5)
︡04981179-5b33-4f69-9d45-d134090bb821︡{"stdout":"4\n"}︡{"done":true}
︠0e84ee9b-eaa1-47b0-a37f-55e8a2ae4996︠
#Greatest common divisor
gcd(45,27)
︡3308ba34-5bd9-4c44-bb88-993efe37e706︡{"stdout":"9\n"}︡{"done":true}
︠305d5be3-0481-4be5-8506-d4a47662a3efs︠
#Solving the LDE a*x+b*y=gcd(a,b)
#Example. a=7, b=5
xgcd(7,5)
︡8aa161d9-3488-42ff-9f23-5c0323d6f3c7︡{"stdout":"(1, -2, 3)\n"}︡{"done":true}
︠95fe9c3e-4220-4d9f-8d7a-fb2df881f606︠
#Check:
7*(-2)+5*3==1
︡203d7734-dd44-4497-b357-03613d40d0e4︡{"stdout":"True\n"}︡{"done":true}
︠d3496662-3af3-4803-bb90-07f78b27f4b9︠
#Including legend into a plot with multiple graphs
#Example.
f(x)=1-x; g(x)=x^2-2*x
p=plot(f(x),0,2,legend_label='line',color='green',thickness=2)
q=plot(g(x),0,2,legend_label='x^2-2x',color='red',thickness=2)
show(p+q,figsize=[4,2])
︡88c6fff1-2bbb-427e-95ff-a600c2c4cebc︡{"file":{"filename":"/home/user/.sage/temp/project-ea172186-f00f-4448-bb09-d8a5df9835f9/315/tmp_Emim16.svg","show":true,"text":null,"uuid":"482316d3-eed2-41db-a263-f84bf376fdeb"},"once":false}︡{"done":true}
︠56a6f74f-85c7-4819-98cc-458ce2566d6as︠

#Exercise 1 (demo): Goldbach conjecture
def my_goldbach(n): #n must be even
    L=prime_range(n/2)
    S=[]
    for c in L:
        if is_prime(n-c):
            S.append([c,n-c])
    return S
my_goldbach(100)
︡3f6ebff0-1866-4e15-a8eb-bbcc304a530c︡{"stdout":"[[3, 97], [11, 89], [17, 83], [29, 71], [41, 59], [47, 53]]\n"}︡{"done":true}
︠f6a46b3b-4996-4c47-9a31-f343ecfd8dc6s︠
#Exercise 2(a): Eratosthenes algorithm (template)
reset()
#Simple code snippet
#Input: list of integers L and an integer m
# Output: list L with multiples of m removed
def remove_multiple(m,L):
    for c in L:
        if (c % m)==0:
            L.remove(c)
    return L
#Example
L=[2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20];
remove_multiple(2,L)
︡8239d29b-aadb-4803-9c97-ce6f907197c9︡{"stdout":"[3, 5, 7, 9, 11, 13, 15, 17, 19]\n"}︡{"done":true}
︠1519a39e-98a3-4b1d-9ebc-c120994a2cbes︠
remove_multiple(L[0],L)# Think what L[0] is in this command
︡b1cdd3b3-788c-4bd6-a17e-b9b64f3cc0ad︡{"stdout":"[5, 7, 11, 13, 17, 19]\n"}︡{"done":true}
︠dfc320fa-134a-4184-85e6-cd9916ebcfe3s︠
#Exercise 3: Eratosthenes algorithm
def simple_erato(n):#Fill in the blanks
    S=[] # S is a placeholder for primes <k that will be removed
    L=[j for j in range(2,n+1)]# list of numbers <=n with L[0]=2; L will be changing
    k= floor(sqrt(n)) # Fact:for any composite number less or equal n there is a prime factor <=k
    while L[0]<=k:
        S.append(L[0])
        remove_multiple(L[0],L)
    return S+L
simple_erato(20)
︡8e80811f-64da-488c-bb18-122cafd16f6f︡{"stdout":"[2, 3, 5, 7, 11, 13, 17, 19]\n"}︡{"done":true}
︠705dfa56-3bc0-4978-8e8a-fddc291e743fs︠


︡8db83dd2-3b79-4c24-88da-d958b6eca124︡{"done":true}
︠ad7c7953-8765-4de1-a651-0c1a535fe1c3s︠
#Alternative template for Eratosthenes algorithm
def fancy_erato(n):
    S=[] # S is a placeholder for primes <k
    L=[j for j in range(2,n+1)]# list of numbers from <=n with L[0]=2; L will be changing
    k= floor(sqrt(n)) # for any composite number less or equal n there is a prime factor <=k
    while L[0]<=k:
        S.append(L[0])
        L=filter(lambda a: a % L[0]!=0, L) # compact form of our function remove_multiple
        # != means "not equal"; when a%L[0]!=0 is False, the element a is filtered (removed)
    S=S+L
    return S

fancy_erato(20)
︡9d8f25f0-5719-4122-9cb5-2a5a13ce03c3︡{"stdout":"[2, 3, 5, 7, 11, 13, 17, 19]\n"}︡{"done":true}
︠1d5187d8-e63d-44c4-b2eb-a92563d965b1︠
︡51e53b34-e112-47ea-b764-bb901f8abb85︡
︠3129ef7a-2c04-450b-8127-56a1d3166e37s︠
#Exercise 3 (template): Fermat's factorization algorithm is based on the following fact:
#Every odd number N is the difference of squares, N=a^2-b^2=(a-b)*(a+b).
def fermat_factors(N): # N should be odd
    a = math.ceil(sqrt(N))# calling math is important. It returns a as decimal number
    b = math.sqrt(a^2-N)
    print(a,b)
    while floor(b)-b!=0:#The condition should verify if b is an integer
        a = a + 1# Alternative Python-like form of this command: a+=1
        b = math.sqrt(a^2-N)
        print a,b
    print "a =", a
    print "b =", b
    print "c =", a+b
    print "d =", a-b
#Test 
fermat_factors(20)


︡e4b0ec6a-5c91-4be0-824c-249fdad5ec7c︡{"stdout":"(5.0, 2.23606797749979)\n6.0 4.0\na = 6.0\nb = 4.0\nc = 10.0\nd = 2.0\n"}︡{"done":true}
︠b3453d37-1215-4b62-8ded-32e833837115s︠
#Exercise 4: Counting primes
#Directions
#Sage uses notation prime_pi for Prime Counting Function. Sage also knows function Li.
#Define the function x/log(x). Make plots of the the three functions and store them under names of your choice.Include legend into each plot. Then plot all three plots in one figure using command show.
f(x)=x/log(x)
p1=plot(prime_pi(x),3,1000,color="green",figsize=[4,3],legend_label="Pi")
p2=plot(li(x),3,1000,color="red",figsize=[4,3],legend_label="Li")
p3=plot(f(x),3,1000,color="blue",figsize=[4,3],legend_label="f(x)")
show(p1+p2+p3,figsize=[4,3])
︡f98004cd-07e1-4e08-8e1b-767fe1673eab︡{"file":{"filename":"/home/user/.sage/temp/project-fdca50c1-5926-45c5-a180-d8d3e7f819b2/317/tmp_jVcB7A.svg","show":true,"text":null,"uuid":"97f94cc4-dd48-42d2-af06-709c53d230df"},"once":false}︡{"done":true}
︠a9eeb328-96da-4294-940d-7739c7c5d62cs︠
#Exercise 8: Constructing one PPT (template)
#Input: a rational number r, 0<r<1
#Output: legs of the ppt defined by
def one_ppt(r):
    m=numerator(r)
    n=denominator(r)
    if m%2 - n%2 ==0:
        print('both m and n are odd')
    else:
        a=2*m+1;
        b=2*n+1;
        return [a,b,sqrt(a^2+b^2)]
one_ppt(2/3)
︡6ec5972b-7e59-4f5d-b54b-551740e6f9f5︡{"stdout":"[5, 7, sqrt(74)]\n"}︡{"done":true}
︠cd9596be-7c91-4cb2-a566-45779da370bd︠
#Check:
sqrt(5^2+12^2)
︡3ce1813a-7ce6-4558-ba1d-196674cc7870︡{"stdout":"13\n"}︡{"done":true}









